# coding: utf-8

from __future__ import annotations
from datetime import date, datetime  # noqa: F401

import re  # noqa: F401
from typing import Any, Dict, List, Optional  # noqa: F401

from pydantic import AnyUrl, BaseModel, EmailStr, Field, validator  # noqa: F401
from fuse_client.models.webhook_source import WebhookSource
from fuse_client.models.webhook_type import WebhookType


class WebhookEvent(BaseModel):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.

    WebhookEvent - a model defined in OpenAPI

        type: The type of this WebhookEvent.
        financial_connection_id: The financial_connection_id of this WebhookEvent.
        environment: The environment of this WebhookEvent.
        source: The source of this WebhookEvent.
        verification_token: The verification_token of this WebhookEvent [Optional].
        remote_data: The remote_data of this WebhookEvent.
    """

    type: WebhookType = Field(alias="type")
    financial_connection_id: str = Field(alias="financial_connection_id")
    environment: str = Field(alias="environment")
    source: WebhookSource = Field(alias="source")
    verification_token: Optional[str] = Field(alias="verification_token", default=None)
    remote_data: object = Field(alias="remote_data")

WebhookEvent.update_forward_refs()
