# coding: utf-8

from __future__ import annotations
from datetime import date, datetime  # noqa: F401

import re  # noqa: F401
from typing import Any, Dict, List, Optional  # noqa: F401

from pydantic import AnyUrl, BaseModel, EmailStr, Field, validator  # noqa: F401
from openapi_server.models.financial_connections_account_institution import FinancialConnectionsAccountInstitution
from openapi_server.models.financial_connections_investment_account_balance import FinancialConnectionsInvestmentAccountBalance


class FinancialConnectionsInvestmentAccount(BaseModel):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.

    FinancialConnectionsInvestmentAccount - a model defined in OpenAPI

        remote_id: The remote_id of this FinancialConnectionsInvestmentAccount.
        fingerprint: The fingerprint of this FinancialConnectionsInvestmentAccount.
        institution: The institution of this FinancialConnectionsInvestmentAccount [Optional].
        last_four: The last_four of this FinancialConnectionsInvestmentAccount [Optional].
        name: The name of this FinancialConnectionsInvestmentAccount.
        type: The type of this FinancialConnectionsInvestmentAccount.
        subtype: The subtype of this FinancialConnectionsInvestmentAccount [Optional].
        balance: The balance of this FinancialConnectionsInvestmentAccount.
    """

    remote_id: str = Field(alias="remote_id")
    fingerprint: str = Field(alias="fingerprint")
    institution: Optional[FinancialConnectionsAccountInstitution] = Field(alias="institution", default=None)
    last_four: Optional[str] = Field(alias="last_four", default=None)
    name: str = Field(alias="name")
    type: str = Field(alias="type")
    subtype: Optional[str] = Field(alias="subtype", default=None)
    balance: FinancialConnectionsInvestmentAccountBalance = Field(alias="balance")

FinancialConnectionsInvestmentAccount.update_forward_refs()
